package com.unis.hlht.cjlksj.server.controller;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

/**
 * @description:读excle创建表
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/07/02-15:36
 **/
public class CreateTable {
    public static void main(String[] args) {
//        String path = "F:\\Sogou\\";
        String path = "C:\\Users\\18513\\Desktop\\createTableExc";
//        String path = "D:\\Project_DATA\\shanxixiangmu_mwd_ldq\\交接文档\\后续交接东西\\粮库标准\\建表excel\\";
        List<String> tableList = new ArrayList<>();

        tableList.add("ODS_UP_DWXXJK");

        try {
            File file = new File(path);        //获取其file对象
            File[] fs = file.listFiles();    //遍历path下的文件和目录，放在File数组中
            int i = 0;
            for (File f : fs) {                    //遍历File[]数组
                if (!f.isDirectory()) {
                    String name = f.getName().replace(".xlsx", "");
                    if (tableList.contains(name)) {
//				if(tableList.contains(name)) {
                        String absolutePath = f.getAbsolutePath();
//						System.out.println(absolutePath);
//						i ++;

                        CreateTableInfo(absolutePath);
//						System.err.println("------------" + i);
//				}
                    }
                }
            }
        } catch (Exception e) {
            // TODO Auto-generated catch block
//			e.printStackTrace();
        }
    }


    public static void CreateTableInfo(String excelPath) {
        try {
            //String encoding = "GBK";
            File excel = new File(excelPath);
            //判断文件是否存在
            if (excel.isFile() && excel.exists()) {
                //.是特殊字符，需要转义！！！！！
                String[] split = excel.getName().split("\\.");
                Workbook wb;
                //根据文件后缀（xls/xlsx）进行判断
                if ("xls".equals(split[1])) {
                    //文件流对象
                    FileInputStream fis = new FileInputStream(excel);
                    wb = new HSSFWorkbook(fis);
                } else if ("xlsx".equals(split[1])) {
//                	System.out.println(split[1]);
                    wb = new XSSFWorkbook(excel);
                } else {
                    System.out.println("文件类型错误!");
                    return;
                }
                // 文件名设置为表名
                String tableName = split[0];

                //开始解析
                //读取sheet 0
                Sheet sheet = wb.getSheetAt(0);
                //第一行是列名，所以不读
                int firstRowIndex = sheet.getFirstRowNum() + 1;
                int lastRowIndex = sheet.getLastRowNum();
//                System.out.println("firstRowIndex: " + firstRowIndex);
//                System.out.println("lastRowIndex: " + lastRowIndex);

                StringBuilder sql = new StringBuilder();
                sql.append("create table ");
                sql.append(tableName);
                sql.append(" (");
                //备注集合
                List<StringBuilder> comments = new ArrayList<>();


//                int a = 0;
//                String oldc = "";
//                String lodz = "";
                //遍历行
                for (int rIndex = firstRowIndex; rIndex <= lastRowIndex; rIndex++) {
                    StringBuilder comment = new StringBuilder();
                    comment.append("comment on column ");
                    comment.append(tableName);
                    comment.append(".");
                    Row row = sheet.getRow(rIndex);
                    if (row != null && (row.getCell(1) != null)) {
                        //列值
                        //上传标准备注
                        Cell com1 = row.getCell(0);
                        Cell com2 = row.getCell(4);

//                        boolean mergedRegion = isMergedRegion(sheet, rIndex, 0);
//                        if(mergedRegion) {
//                        	a ++;
//                        	lodz = row.getCell(1).toString();
//                        }else {
//                        	a= 0;
//                        	oldc = "";
//                        	lodz = "";
//                        }
//                        if(a > 0) {
//                        	oldc += mergedRegion+com2.toString()+"\n";
//                        }
//                        System.out.println( row.getCell(1).toString() +mergedRegion+com2.toString());

                        //字段名
                        String columName = row.getCell(1).toString();
                        if (StringUtils.isNotBlank(columName)) {
                            sql.append("\n");
                            sql.append(columName + " ");
                            comment.append(columName);
                            comment.append(" is '");
                            comment.append(com1.toString());
                            if (com2 != null) {
                                comment.append(com2.toString());
                            }
                            comment.append("';");
                            comments.add(comment);
                            //数据类型
                            String lx = row.getCell(2).toString();
                            if (lx.contains("String")) {
                                sql.append(lx.replaceAll("String", "VARCHAR2"));
                            } else if (lx.contains("Integer")) {
                                sql.append(lx.replaceAll("Integer", "NUMBER"));
                            } else if (lx.contains("Decimal")) {
                                sql.append(lx.replaceAll("Decimal", "NUMBER"));
                            } else {
                                sql.append(lx);
                            }
                            //是否必填
                            //操作标志
                            if (columName.equalsIgnoreCase("czbz")) {
                                sql.append(" default 'i'");
                            }
                            String isNull = row.getCell(3).toString();
                            if (isNull != null && (isNull.equalsIgnoreCase("Y") || isNull.equalsIgnoreCase("K"))) {
                                sql.append(" not null");
                            }
                            sql.append(",");
                        }
                    }
                }
                sql.append("ID VARCHAR2(32), IS_UPLOAD NUMBER(1) default 0,LOAD_DATE DATE);");

                System.out.println("--建表");
                System.out.println(sql.toString());
                System.out.println("--备注");

                String ab = "";
                for (StringBuilder comment : comments) {
                    System.out.println(comment.toString());
                    ab += comment.toString() + "\n";
                }

                String www = "--建表\n" + sql.toString() + "\n--备注" + ab;
                writeTxt("C:\\Users\\18513\\Desktop\\createTableExc\\sql\\sql.sql", www);
            } else {
                System.out.println("找不到指定的文件");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 判断指定的单元格是否是合并单元格
     *
     * @param sheet
     * @param row    行下标
     * @param column 列下标
     * @return
     */
    private static boolean isMergedRegion(Sheet sheet, int row, int column) {
        int sheetMergeCount = sheet.getNumMergedRegions();
        for (int i = 0; i < sheetMergeCount; i++) {
            CellRangeAddress range = sheet.getMergedRegion(i);
            int firstColumn = range.getFirstColumn();
            int lastColumn = range.getLastColumn();
            int firstRow = range.getFirstRow();
            int lastRow = range.getLastRow();
            if (row >= firstRow && row <= lastRow) {
                if (column >= firstColumn && column <= lastColumn) {
                    return true;
                }
            }
        }
        return false;
    }

    public static void writeTxt(String file, String conent) {
        BufferedWriter out = null;
        try {
            out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file, true)));
            out.write(conent + "\r\n");
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                out.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
