package com.unis.hlht.cjlksj.server.controller.datashow;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.unis.hlht.cjlksj.server.dto.datashow.RegexDataDTO;
import com.unis.hlht.cjlksj.server.server.RegexDataserver;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.Node;
import org.dom4j.io.SAXReader;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.unis.hlht.cjlksj.server.dto.upload.DataQueryDTO;
import com.unis.hlht.cjlksj.server.mapper.GrabResultMapper;
import com.unis.hlht.cjlksj.server.mapper.LiangKuApiMapper;
import com.unis.hlht.cjlksj.server.mapper.SysUploadErrorResultMapper;
import com.unis.hlht.cjlksj.server.server.DataUpLoadServer;
import com.unis.hlht.cjlksj.server.utils.RootResult;

import lombok.extern.log4j.Log4j2;

/**
 * 功能描述: 功能测试controller层
 *
 * @Auther: 蒋青茂
 * @Date: 2019-3-19 10:30
 */
@SuppressWarnings("all")
@Log4j2
@RestController(value = "/test2")
public class RegexDataController {

    @Autowired
    private LiangKuApiMapper mapper;
    @Autowired
    private GrabResultMapper regexMapper;
    @Autowired
    private SysUploadErrorResultMapper sysUploadErrorResultMapper;
    @Autowired
    private RegexDataserver regexDataserver;


    @PostMapping(value = "getTableHeadList")
    public List<Map> getTableHeadList(DataQueryDTO dto) {
        String tableName = dto.getTableName();
        if (StringUtils.isEmpty(tableName)) {
            tableName = "DIM_HY_CCQYJBXXQKB";
        }
        String sql = "select * from sys_datadict  where zd_f_bm = '" + tableName + "'";
//		String sql = "select ZDMC,ZDBM from sys_datadict  where zd_f_bm = '"+tableName+"'";
        List<Map> cList = sysUploadErrorResultMapper.select(sql);
        return cList;
    }

    @PostMapping(value = "getTableDataList")
    public PageInfo<Map> getTableDataList(@RequestBody DataQueryDTO dto) {
        String tableName = dto.getTableName();
        if (StringUtils.isEmpty(tableName)) {
            tableName = "ODS_UP_DWXXJK";
        }
        String sql = "select ZDMC,ZDBM from sys_datadict  where zd_f_bm = '" + tableName + "'";
        List<Map> cList = sysUploadErrorResultMapper.select(sql);

        StringBuffer dataQuery = new StringBuffer();
        dataQuery.append("select ");
        for (Map map : cList) {
            String zdbm = map.get("ZDBM").toString();
            if (zdbm.equals("KDWTSL")) {
                continue;
            }
            dataQuery.append(zdbm + ",");
        }
        sql = dataQuery.substring(0, dataQuery.lastIndexOf(","));
        sql = sql + ",ID from " + tableName + " where 1=1 ";

        String tyshxydm = dto.getTyshxydm();
        if (!StringUtils.isEmpty(tyshxydm)) {
            sql += (" and tyshxydm = '" + tyshxydm + "'");
        }

        String queryColumn = dto.getQueryColumn();
        String queryColumnVal = dto.getQueryColumnVal();
        if (!StringUtils.isEmpty(queryColumn) && !StringUtils.isEmpty(queryColumnVal)) {
            sql += (" and " + queryColumn + " like '%" + queryColumnVal + "%'");
        }

        PageHelper.startPage(dto.getPageNo(), dto.getPageSize());
        //新增每个库点的问题数据  start
        List<Map> select = sysUploadErrorResultMapper.select(sql);
        List<Map> tableDetailList = getTableDetail(tableName);
        for (int i = 0; i < select.size(); i++) {
            Map map = select.get(i);
            String dwmc = map.get("DWMC").toString();
            String dwdm = map.get("DWDM").toString();
            String s = dwmc + "-" + dwdm;
            map.put("KDWTSL", 0);
            for (int j = 0; j < tableDetailList.size(); j++) {
                Map map1 = tableDetailList.get(j);
                String kdmc = map1.get("KDMC").toString();
                List<Map> kdwt = (List<Map>) map1.get("kdwt");
                if (s.equals(kdmc)) {
                    map.replace("KDWTSL", kdwt.size());
                }
            }

        }
        //新增每个库点的问题数据  end
        PageInfo<Map> pageInfo = new PageInfo<>(select);
        return pageInfo;
    }


    @PostMapping(value = "getTableDataListYj")
    public RootResult<Object> getTableDataListYj(@RequestBody DataQueryDTO dto) {
        String tableName = dto.getTableName();
        if (StringUtils.isEmpty(tableName)) {
            tableName = "DIM_HY_CCQYJBXXQKB";
        }
        String sql = "select ZDMC,ZDBM from sys_datadict  where zd_f_bm = '" + tableName + "'";
        List<Map> cList = sysUploadErrorResultMapper.select(sql);

        StringBuffer dataQuery = new StringBuffer();
        dataQuery.append("select ");
        for (Map map : cList) {
            String zdbm = map.get("ZDBM") + ",";
            dataQuery.append(zdbm);
        }
        sql = dataQuery.substring(0, dataQuery.lastIndexOf(","));
        sql = sql + " from " + tableName + " where 1=1 ";

        String tyshxydm = dto.getTyshxydm();
        if (!StringUtils.isEmpty(tyshxydm)) {
            sql += (" and tyshxydm = '" + tyshxydm + "'");
        }

        String queryColumn = dto.getQueryColumn();
        String queryColumnVal = dto.getQueryColumnVal();
        if (!StringUtils.isEmpty(queryColumn) && !StringUtils.isEmpty(queryColumnVal)) {
            sql += (" and " + queryColumn + " like '%" + queryColumnVal + "%'");
        }

        List<Map> dataList = sysUploadErrorResultMapper.select(sql);
//		JSONArray array = new JSONArray();
        for (Map map : dataList) {
//			JSONObject obj = new JSONObject();
            map.put("companyName", map.get("QYMC"));
            map.put("companyAddress", map.get("YYDZ"));
            map.put("lon", map.get("JD"));
            map.put("lat", map.get("WD"));
            map.put("legalName", map.get("FDDBR"));
            map.put("phone", map.get("BGDH"));
//			array.add(array);
        }

        RootResult<Object> root = new RootResult<>();
        root.setInfoCode("200");
        root.setCode("200");
        root.setData(dataList);
        return root;
    }


    public static void main(String[] args) {
        String a = "s a,b,c,";
        System.out.println(a.substring(0, a.lastIndexOf(",")));
    }

    /**
     * @return
     */
    @PostMapping(value = "getTableList")
    public List<Map> getTableList() {
        // 加载数据校验规则
        org.dom4j.Document document = getDom(
                DataUpLoadServer.class.getClassLoader().getResourceAsStream("config/shanxi_shengdu.xml"));
        Element root = document.getRootElement();
        Element columnEle = null;
        String tableName = null, remark = null;
        List tableEles = root.selectNodes("/tables/table");
        List<Map> mlist = new ArrayList<>();
        if (tableEles != null) {
            for (int i = 0; i < tableEles.size(); i++) {
                List<String> infoList = new ArrayList<String>();
                StringBuffer sb = new StringBuffer();
                Element ele = (Element) tableEles.get(i);
                tableName = ele.attributeValue("name");
                remark = ele.attributeValue("col");

                Map<String, String> map = new HashMap<>();
                map.put("tableName", tableName);
                map.put("remark", remark);
                mlist.add(map);
            }
        }
        return mlist;
    }

    /**
     * @return
     */
    @PostMapping(value = "getTableDetail")
    public List<Map> getTableDetail(String queryTableName) {
        // 加载数据校验规则
        org.dom4j.Document document = getDom(
//				DataUpLoadServer.class.getClassLoader().getResourceAsStream("config/shanxi.xml"));
                DataUpLoadServer.class.getClassLoader().getResourceAsStream("config/shanxi_shengdu.xml"));
        Element root = document.getRootElement();
        Element columnEle = null;
        List<Node> columnList = null;
        String tableName = null, remark = null, columnname = null, sql = null;
        List tableEles = root.selectNodes("/tables/table");
        List<Map> mlist = new ArrayList<>();
        if (tableEles != null) {
            for (int i = 0; i < tableEles.size(); i++) {
                List<String> infoList = new ArrayList<String>();
                Element ele = (Element) tableEles.get(i);
                tableName = ele.attributeValue("name");
                remark = ele.attributeValue("col");
                if (queryTableName.equals(tableName)) {
                    columnList = ele.selectNodes("column[@sql|@remark]");
                    int columnSize = columnList != null ? columnList.size() : 0;
                    if (columnSize > 0) {
                        for (int x = 0; x < columnSize; x++) {
                            columnEle = (Element) columnList.get(x);
                            columnname = columnEle.getTextTrim().toUpperCase();
                            sql = columnEle.attributeValue("sql");
                            List<Map> list = regexMapper.select(sql);
                            remark = columnEle.attributeValue("remark");
                            for (Map map : list) {
                                String info = map.get("QYXX") + "";
                                String ID = map.get("ID").toString();
                                String errorColumn = map.get("ERRORCOLUMN") + "";
                                Map<String, String> vM = new HashMap<String, String>();
                                vM.put("ID", ID);
                                vM.put("TNAME", tableName);
                                vM.put("KDMC", info);
                                vM.put("INFO", "问题：" + remark);
                                vM.put("VAL", errorColumn);
                                vM.put("NAME", columnname);
                                if (mlist.contains(vM) == false) {
                                    mlist.add(vM);
                                }
                            }
                        }
                    }
                    break;
                }
            }
        }

        List<Map> kdList = new ArrayList<>();
        String kdmc_key = "KDMC";
        String kdwt_key = "kdwt";
        for (Map map : mlist) {
            String kdmc = map.get(kdmc_key) + "";

            boolean isContain = false;
            for (Map<String, Object> map2 : kdList) {
                String kdmc2 = map2.get(kdmc_key) + "";
                if (kdmc.equals(kdmc2)) {
                    List<Map<String, Object>> kdQuestionList = (List<Map<String, Object>>) map2.get(kdwt_key);
                    kdQuestionList.add(map);
                    isContain = true;
                }
            }

            if (!isContain) {
                Map<String, Object> kdMap = new HashMap<>();
                List<Map<String, Object>> kdQuestionList = new ArrayList<>();
                kdQuestionList.add(map);
                kdMap.put(kdmc_key, kdmc);
                kdMap.put(kdwt_key, kdQuestionList);
                kdList.add(kdMap);
            }
        }
        return kdList;
    }


    @ApiOperation(value = "根据表名和ID获取问题数据列表", notes = "")
    @PostMapping(value = "getErrorListByTableID")
    public List<Map> getErrorListByTableID(@RequestParam String queryTableName, @RequestParam String tableID) {
        List<Map> errorList = regexDataserver.getErrorListByTableID(queryTableName, tableID);
        return errorList;
    }

    @ApiOperation(value = "")
    @PostMapping(value = "UpdateByTableId")
    public String UpdateByTableId(@RequestBody RegexDataDTO regexDataDTO) {
        regexDataserver.UpdateByTableId(regexDataDTO);
        return "200";
    }


    public List<Map> getData() {
        // 加载数据校验规则
        org.dom4j.Document document = getDom(
                DataUpLoadServer.class.getClassLoader().getResourceAsStream("config/shanxi_shengdu.xml"));
        Element root = document.getRootElement();
        List<Node> columnList = null;
        Element columnEle = null;
        String sql = null, columnname = null, value = null, regex = null, tableName = null, remark = null;

        List tableEles = root.selectNodes("/tables/table");
        List<Map> mlist = new ArrayList<>();
        if (tableEles != null) {
            for (int i = 0; i < tableEles.size(); i++) {
                List<String> infoList = new ArrayList<String>();
                StringBuffer sb = new StringBuffer();
                Element ele = (Element) tableEles.get(i);
                tableName = ele.attributeValue("name");
                sb.append("表名：").append(tableName);
                sb.append("\n");
                columnList = ele.selectNodes("column[@sql|@remark]");
                int columnSize = columnList != null ? columnList.size() : 0;
                if (columnSize > 0) {
                    for (int x = 0; x < columnSize; x++) {
                        columnEle = (Element) columnList.get(x);
                        columnname = columnEle.getTextTrim().toUpperCase();
                        sql = columnEle.attributeValue("sql");
                        List<Map> list = regexMapper.select(sql);
                        remark = columnEle.attributeValue("remark");
                        sb.append("\t");
                        sb.append("问题：" + columnname + remark);
                        sb.append("\n\t***********************相关数据****************************\n");
                        for (Map map : list) {
                            String info = map.get("QYXX") + "";
                            String errorColumn = map.get("ERRORCOLUMN") + "";
                            sb.append("\t\t");
                            sb.append(info);
                            sb.append("\n");
                            Map<String, String> vM = new HashMap<String, String>();
                            vM.put("TNAME", tableName);
                            vM.put("KDMC", info);
                            vM.put("INFO", "问题：" + remark);
                            vM.put("VAL", errorColumn);
                            vM.put("NAME", columnname);
                            if (mlist.contains(vM) == false) {
                                mlist.add(vM);
                            }
                        }
                    }
                }
                // CreateTable.writeTxt("E://" + DateUtil.getCurrentStringDate() +
                // "国家局反馈部分问题.txt", sb.toString());
            }
        }
        return mlist;
    }

    public static org.dom4j.Document getDom(InputStream in) {
        org.dom4j.Document document = null;
        SAXReader saxReader = null;
        saxReader = new SAXReader();
        if (in != null) {
            try {
                document = saxReader.read(in);
            } catch (DocumentException e) {
                e.printStackTrace();
            }
        }
        return document;
    }
}
