package com.unis.hlht.cjlksj.server.datagrabtest;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import lombok.extern.slf4j.Slf4j;

/**
 * 
 * @ClassName: DBHelper
 * @Description: TODO(测试能否抓取到粮库的数据)  
 * @author ldq
 * @date 2021年4月9日
 *
 */
@Slf4j
public class LiangKuDataGrabTest {

	//抓取地址单库地址
	static String graburl = "http://172.16.11.250:8888/instruction/grabOneTbaleAndOneKd";
	static String grabParams = "table=DIM_HY_KQQKB&heart_kdmc=";
	
	
	public static void main(String[] args) {
		String beginTime = "2021-04-09 14:30:01";
		begin(beginTime);
	}
	
	/**
	 * 注意：使用时 需要将待抓取的库点信息录入到GrabKd.txt  当前包路径
	 * @param beginTime 查询抓取日志的时间
	 */
	public static void begin(String beginTime) {
		try {
			LiangKuDataGrabTest dbHelper = new LiangKuDataGrabTest();
			Connection conn = dbHelper.conn();
			// 1获取库区名称
			List<String> list = TxtHelper.readTXT();
			
			// # SQL 语句
			String backSql = "select kdmc from dim_hy_kqqkb_back where kdbm = '%s'";
			String delBackSql = "delete from dim_hy_kqqkb where kdbm = '%s'";
			String delSql = "delete from dim_hy_kqqkb where kdbm = '%s'";
			String selSql = "select kdbm,kdmc from dim_hy_kqqkb where kdmc = '%s'";
			String exeBackSql = "insert into dim_hy_kqqkb_back select * from dim_hy_kqqkb where kdbm= '%s'";
			String log_sql_selectData1 = "SELECT * FROM GRAB_RESULT  " + "WHERE  CREATE_TIME >=  to_date('" + beginTime
					+ "','yyyy-MM-dd HH24:MI:SS') and Table_Name = 'DIM_HY_KQQKB'";

			for (String kd : list) {
				//心跳中的全名
				String grabKd= kd;
				//库区信息中名称
				kd = kd.substring(kd.lastIndexOf("-") + 1);
//				Map<String, Object> map = dbHelper.executeResultOne(conn, String.format(selSql, kd));
//				if (map != null) {
//					String kdmc = map.get("KDMC") + "";
//					String kdbm = map.get("KDBM") + "";
//
//					System.out.println("--信息存在：" + kd);
//					
//					// 执行备份
//					System.out.println("--执行备份：" + kd);
//					Map<String, Object> backObj = dbHelper.executeResultOne(conn, String.format(backSql, kdbm));
//					if (backObj != null) {
//						dbHelper.executeResultOne(conn, String.format(delBackSql, kdbm));
//					}
//					dbHelper.executeResultOne(conn, String.format(exeBackSql, kdbm));
//
//					// 执行删除
//					System.out.println("--执行删除：" + kd);
//					dbHelper.executeResultOne(conn, String.format(delSql, kdbm));
//				}else {
//					System.out.println("--------------------信息不存在：" + kd);
//				}
				
				
				// 执行抓取任务一标-宝鸡市益门堡粮食仓库粮库
//				System.out.println("--------------------执行抓取开始");
//				String grabPostResultStr = HttpHelp.post(String.format(graburl), grabParams + grabKd);
//				System.out.println("抓取请求日志：" + grabKd + " | "+  graburl+ " | "+ grabPostResultStr);

				// 执行日志查询
				List<Map<String, Object>> logAll = dbHelper.selectAll(conn, log_sql_selectData1);
				if (logAll != null) {
					for (Map<String, Object> map2 : logAll) {
						String RESULT = map2.get("RESULT")+"";
						String TABLE_NAME = map2.get("TABLE_NAME")+"";
						String CREATE_TIME = (map2.get("CREATE_TIME")+"").replace(".0", "");
						System.out.println(CREATE_TIME + "," + "|  表：" + TABLE_NAME + "| 结果：" + RESULT);
					}
				}
				
				System.out.println("--------------------执行抓取结果验证");
				
				// 执行抓取结果验证
				Map<String, Object> verifymap = dbHelper.executeResultOne(conn, String.format(selSql, kd));
				if (verifymap != null) {
					String kdmc = verifymap.get("KDMC") + "";
					String kdbm = verifymap.get("KDBM") + "";
					System.err.println(kd + "--->抓取成功");
				}else {
					System.err.println(kd + "--->抓取失败");
				}
				// 执行抓取失败数据还原

				// 生成抓取日志
			}

			// 关闭数据库
			dbHelper.closeConn(conn);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * Statement 和 PreparedStatement之间的关系和区别. 关系：PreparedStatement继承自Statement,都是接口
	 * 区别：PreparedStatement可以使用占位符，是预编译的，批处理比Statement效率高
	 * 
	 * @return
	 * 
	 * @throws SQLException
	 * @throws IllegalAccessException
	 * @throws InstantiationException
	 */
	public List<Map<String, Object>> selectAll(Connection conn, String sql) throws SQLException {
		PreparedStatement statement = conn.prepareStatement(sql);
		ResultSet rs = statement.executeQuery();
		try {
			List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();
			// 获取结果集结构（元素据）
			ResultSetMetaData rmd = rs.getMetaData();
			// 获取字段数（即每条记录有多少个字段）
			int columnCount = rmd.getColumnCount();
			while (rs.next()) {
				// 保存记录中的每个<字段名-字段值>
				Map<String, Object> rowData = new HashMap<String, Object>();
				for (int i = 1; i <= columnCount; ++i) {
					// <字段名-字段值>
					rowData.put(rmd.getColumnName(i), rs.getObject(i));
				}
				// 获取到了一条记录，放入list
				list.add(rowData);
			}
			return list;
		} catch (Exception ex) {
			ex.printStackTrace();
		}

		close(rs, statement);
		return null;

	}

	public Map<String, Object> executeResultOne(Connection conn, String sql) throws SQLException {
		log.info("SQL:{}", sql);

		PreparedStatement statement = conn.prepareStatement(sql);
		ResultSet rs = statement.executeQuery();
		try {
			Map<String, Object> rowData = new HashMap<String, Object>();
			// 获取结果集结构（元素据）
			ResultSetMetaData rmd = rs.getMetaData();
			// 获取字段数（即每条记录有多少个字段）
			int columnCount = rmd.getColumnCount();
			int lines = 0;
			while (rs.next()) {
				// 保存记录中的每个<字段名-字段值>
				for (int i = 1; i <= columnCount; ++i) {
					// <字段名-字段值>
					rowData.put(rmd.getColumnName(i), rs.getObject(i));
				}
				lines = lines + 1;
			}

			if (lines == 1) {
				return rowData;
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		close(rs, statement);
		return null;

	}

	public void close(ResultSet rs, PreparedStatement statement) throws SQLException {
		// 关闭资源
		rs.close();
		statement.close();
	}

	public void closeConn(Connection conn) throws SQLException {
		// 关闭资源
		conn.close();
	}

	public Connection conn() {
		String URL = "jdbc:oracle:thin:@172.16.11.5:1521/lkdb";
		String USER = "liangku";
		String PASSWORD = "123456";
		// 1.加载驱动程序
		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");
			// 2.获得数据库链接
			Connection conn = DriverManager.getConnection(URL, USER, PASSWORD);
			return conn;
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;

	}
}