package com.unis.hlht.cjlksj.server.entity.liangku;

import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @author mwd
 * @description dim_hy_ccqyjbxxqkb
 * @date 2023-03-22
 */
@Data
public class DimHyCcqyjbxxqkb implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 统一社会信用代码引用ls/t 1714-2018的表4.1,即18位统一社会信用代码
     */
    private String tyshxydm;

    /**
     * 单位代码参考《虚拟内网信息规范》中的单位编码
     */
    private String dwdm;

    /**
     * 企业名称企业全称
     */
    private String qymc;

    /**
     * 企业类型1:粮食仓储企业
     */
    private String qylx;

    /**
     * 注册时间格式：yyyy-mm-dd
     */
    private String zcsj;

    /**
     * 注册资本单位：万元
     */
    private Double zczb;

    /**
     * 资产总额取最近一年的财务报告,此字段需每年财务报告发布后更新。
     */
    private Double zcze;

    /**
     * 法定代表人
     */
    private String fddbr;

    /**
     * 法人身份证号法人身份证号
     */
    private String sfzh;

    /**
     * 法人联系方式国内标准手机号码或固定电话号码,座机号格式:区号-号码
     */
    private String frsjh;

    /**
     * 企业联系人
     */
    private String qylxr;

    /**
     * 办公电话国内标准手机号码或固定电话号码,座机号格式:区号-号码
     */
    private String bgdh;

    /**
     * 注册地址省（自治区、直辖市）市（自治州、区）县或县级市（自治县、街道）详细地址（含门牌号）；
     */
    private String yydz;

    /**
     * 企业邮箱
     */
    private String qydzyx;

    /**
     * 企业网址
     */
    private String qywz;

    /**
     * 传真号码国内标准传真号码,传真号格式:区号-号码
     */
    private String czhm;

    /**
     * 邮政编码
     */
    private String yzbm;

    /**
     * 行政区划代码参照：gb/t2260-2017年区划代码,6位阿拉伯数字组成
     */
    private String xzqhdm;

    /**
     * 上级单位名称上级直管单位名称,如无则不需填
     */
    private String sjdwmc;

    /**
     * 上级单位代码18位统一社会信用代码
     */
    private String sjdwdm;

    /**
     * 库区数油脂库区数粮食库区数
     */
    private Integer kqs;

    /**
     * 仓房数
     */
    private Integer cfs;

    /**
     * 油罐数
     */
    private Integer ygs;

    /**
     * 经度以度数表示。例如：49.500012
     */
    private Double jd;

    /**
     * 纬度以度数表示。例如：49.500012
     */
    private Double wd;

    /**
     * 粮食库区数
     */
    private Integer lskqs;

    /**
     * 油脂库区数
     */
    private Integer yzkqs;

    /**
     * 隶属关系1:中央企业
     */
    private String lsgx;

    /**
     * 企业经济类型gb/t12402经济类型分类编码
     */
    private String qyjjlx;

    /**
     * 企业性质1:行政机关
     */
    private String qyxz;

    /**
     * 开户银行
     */
    private String khyh;

    /**
     * 银行账号
     */
    private String yhzh;

    /**
     * 银行信用等级
     */
    private String yhxydj;

    /**
     * 主营业务1：加工
     */
    private String zyyw;

    /**
     * 经营范围
     */
    private String jyfw;

    /**
     * 操作标志i:新增数据（默认）
     */
    private String czbz;

    /**
     * 最后更新时间该条数据最后更新时间。
     */
    private String zhgxsj;

    /**
     * id
     */
    private String id;

    /**
     * is_upload
     */
    private Integer isUpload;

    /**
     * load_date
     */
    private Date loadDate;

    public DimHyCcqyjbxxqkb() {
    }
}