package com.unis.hlht.cjlksj.server.mapper;


import com.alibaba.fastjson.JSONArray;
import com.unis.hlht.cjlksj.server.utils.OrderID;
import org.apache.commons.lang3.StringUtils;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.jdbc.SQL;

import java.util.*;

@Mapper
public interface DataUploadMapper /*extends MyMapper*/ {

    /**
     * 粮库数据入库
     *
     * @param body 粮库数据
     */
    @InsertProvider(type = SqlProvider.class, method = "getInsertSql")
    void uploadDataInsert(Object body);

    class SqlProvider {

        /**
         * 粮库数据sql拼接
         *
         * @param body 粮库数据
         * @return insert sql
         */
        public String getInsertSql(Object body) {

            String bodyStr = body.toString();
            //表名
            String tableName = bodyStr.substring(bodyStr.indexOf("{") + 2, bodyStr.indexOf(":") - 1);
            //表数据
            String tableDatasStr = bodyStr.substring(bodyStr.indexOf(":") + 1);
            List<Object> tableDatas = JSONArray.parseArray(tableDatasStr);
            //insert
            StringBuilder startSql = new StringBuilder();
            //sql初始化
            startSql.append(" insert all ");

            //表数据字段值
            ArrayList<String> valuesSqls = new ArrayList<>();
            for (Object tableData : tableDatas) {
                //表数据(单条)
                Map<String, Object> tableDataMap = (Map) tableData;

                //字段名拼接start
                StringBuilder keySql = new StringBuilder();
                Set<String> keys = tableDataMap.keySet();
                if (keys != null) {
                    keySql.append(" into ");
                    keySql.append(tableName);
                    keySql.append(" (");
                    int keySize = keys.size();
                    int keysCount = 0;
                    keySql.append("ID,");
                    for (String columnName : keys) {
                        keySql.append(columnName);
                        if (keysCount < keySize - 1) {
                            keySql.append(",");
                        }
                        keysCount++;
                    }
                    keySql.append(") ");
                }//字段名拼接end

                //insert语句 values 后
                StringBuilder after = new StringBuilder();
                //获取columnValue集合
                Collection<Object> values = tableDataMap.values();
                after.append(" values ('");
                after.append(OrderID.get32());
                after.append("',");
                int valuesCount = 0;
                for (Object columnValue : values) {
                    if (columnValue == null) {
                        after.append("null");
                    } else if (columnValue instanceof Integer || columnValue instanceof Long || columnValue instanceof Double
                            || columnValue instanceof Float || columnValue instanceof Boolean) {
                        after.append(columnValue);
                    } else {
                        after.append("'");
                        after.append(columnValue);
                        after.append("'");
                    }
                    if (valuesCount < values.size() - 1) {
                        after.append(",");
                    }
                    valuesCount++;
                }
                after.append(") ");
                valuesSqls.add(keySql.append(after).toString());
            }

            //sql拼接
            StringBuilder tempSql = new StringBuilder();
            for (String valuesSql : valuesSqls) {
                tempSql.append(valuesSql);
            }
            if (StringUtils.isNotBlank(tempSql.toString())) {
                return startSql.append(tempSql).append(" select 1 from dual ").toString();
            }
            return null;
        }
    }

}
