package com.unis.hlht.cjlksj.server.mapper;


import com.unis.hlht.cjlksj.server.utils.IdWorker;
import com.unis.hlht.cjlksj.server.utils.MapUtils;

import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.jdbc.SQL;

import java.sql.Clob;
import java.sql.SQLException;
import java.util.List;
import java.util.Map;
import java.util.Set;

@Mapper
public interface GeneralMapper_back /*extends MyMapper*/ {

    /**
     * 根据逻辑主键获取数据
     *
     * @param tableName    表名
     * @param keys         逻辑主键
     * @param tableDataMap 粮库上传的数据
     * @return 表中数据
     */
    @SelectProvider(type = SqlProvider.class, method = "getByLogickey")
    List<Map> getByLogickey(String tableName, List<String> keys, Map tableDataMap);

    /**
     * 根据主键做逻辑删除操作
     *
     * @param id        数据主键
     * @param tableName 表名
     */
    @UpdateProvider(type = SqlProvider.class, method = "deleteByPrimaryKey")
    void deleteByPrimaryK(Long id, String tableName);

    /**
     * 根据主键更新表数据
     *
     * @param id           数据主键
     * @param tableName    表名
     * @param tableDataMap 粮库上传的数据
     * @param set 
     */
    @UpdateProvider(type = SqlProvider.class, method = "updateByPrimaryKey")
    void updateByPrimaryK(Map tableDataMap);

    /**
     * 插入数据
     *
     * @param tableName    表名
     * @param tableDataMap 粮库上传的数据
     */
    @InsertProvider(type = SqlProvider.class, method = "insertData")
    void insertData(Map tableDataMap);

    class SqlProvider {

        public String getByLogickey(String tableName, List<String> keys, Map tableDataMap) {
            StringBuilder sql = new StringBuilder();
            sql.append("select id, czbz from ");
            sql.append(tableName);
            sql.append(" where 1 = 1 ");
            for (String key : keys) {
                sql.append("and " + key + " = ");
                Object columnValue = MapUtils.getObjectIgnoreCase(tableDataMap, key);
                if (columnValue instanceof Integer || columnValue instanceof Long || columnValue instanceof Double
                        || columnValue instanceof Float || columnValue instanceof Boolean) {
                    sql.append(columnValue);
                } else {
                    sql.append("'");
                    sql.append(columnValue);
                    sql.append("'");
                }
            }
            return sql.toString();
        }

        @SuppressWarnings("unchecked")
        public String deleteByPrimaryKey(Long id, String tableName) {
            StringBuilder sql = new StringBuilder();
            sql.append("update ");
            sql.append(tableName);
            sql.append(" set czbz = 'd' where id = ");
            sql.append(id);
            return sql.toString();
        }

        @SuppressWarnings("unchecked")
		public String updateByPrimaryKey(Map tableDataMap) {
			SQL sql = new SQL();
			sql.UPDATE(tableDataMap.get("tableName")+"");
			Set<String> keySet = tableDataMap.keySet();
			for (String cloumn : keySet) {
				Object columnValue = tableDataMap.get(cloumn);
				if(cloumn.equals("tableName") == false&& cloumn.equals("id") == false ) {
					if (cloumn.toString().equalsIgnoreCase("czbz")) {
						sql.SET(cloumn + "=" + "'u'");
					} else if (columnValue instanceof Integer || columnValue instanceof Long || columnValue instanceof Double
							|| columnValue instanceof Float || columnValue instanceof Boolean) {
						sql.SET(cloumn + "=" + columnValue);
					} else if((columnValue+"").length() > 4000){
						
						sql.SET(cloumn + "=#{" + cloumn + ",jdbcType=CLOB}");
					}else {
						sql.SET(cloumn + "= '" + columnValue + "'");
					}
				}
			}
			sql.WHERE("id = " + tableDataMap.get("id")+"");
			return sql.toString();
        	
        	
//            int count = 0;
//            StringBuilder sql = new StringBuilder();
//            sql.append("update ");
//            sql.append(tableName);
//            sql.append(" set ");
//            for (Object colu : tableDataMap.keySet()) {
//                Object columnValue = tableDataMap.get(colu);
//                if (columnValue != null && !columnValue.toString().equalsIgnoreCase("null")) {
//                    sql.append(colu);
//                    sql.append(" = ");
//                    if (colu.toString().equalsIgnoreCase("czbz")) {
//                        sql.append("'u'");
//                    } else if (columnValue instanceof Integer || columnValue instanceof Long || columnValue instanceof Double
//                            || columnValue instanceof Float || columnValue instanceof Boolean) {
//                        sql.append(columnValue);
//                    } else {
//                        sql.append("'");
//                        sql.append(columnValue);
//                        sql.append("'");
//                    }
//                    if (count < tableDataMap.keySet().size() - 1) {
//                        sql.append(",");
//                    }
//                    count++;
//                }
//            }
//            sql.append(" where id = ");
//            sql.append(id);
//            return sql.toString();
        }

        @SuppressWarnings("unchecked")
        public String insertData(Map tableDataMap) {
        	 SQL sql = new SQL(); 
        	 sql.INSERT_INTO(tableDataMap.get("tableName")+"");
        	 sql.VALUES("id", IdWorker.nextId()+"");
			Set<String> keySet = tableDataMap.keySet();
             for (String cloumn : keySet) {
            	 Object columnValue = tableDataMap.get(cloumn);
 				if(cloumn.equals("tableName") == false) {
					if (cloumn.toString().equalsIgnoreCase("czbz")) {
						sql.VALUES(cloumn, "'i'");
					} else if (columnValue instanceof Integer || columnValue instanceof Long || columnValue instanceof Double
							|| columnValue instanceof Float || columnValue instanceof Boolean) {
						sql.VALUES(cloumn  ,  "" + columnValue);
					} else if((columnValue+"").length() > 4000){
						sql.VALUES(cloumn , "#{" + cloumn + ",jdbcType=CLOB}");
					}else {
						sql.VALUES(cloumn  , "'" + columnValue + "'");
					}
				}
             }
        	return sql.toString();
        	
        	
//            StringBuilder columnPart = new StringBuilder();
//            StringBuilder valuesPart = new StringBuilder();
//            columnPart.append("insert into ");
//            columnPart.append(tableName);
//            columnPart.append(" (id, ");
//            valuesPart.append(" values (");
//            valuesPart.append(IdWorker.nextId());
//            valuesPart.append(", ");
//            Set<String> keySet = tableDataMap.keySet();
//            int count = 0;
//            for (String cloumn : keySet) {
//                columnPart.append(cloumn);
//                Object columnValue = tableDataMap.get(cloumn);
//                if (cloumn.equalsIgnoreCase("czbz")) {
//                    valuesPart.append("'i'");
//                } else if (columnValue instanceof Integer || columnValue instanceof Long || columnValue instanceof Double
//                        || columnValue instanceof Float || columnValue instanceof Boolean) {
//                    valuesPart.append(columnValue);
//                } else {
//                    valuesPart.append("'");
//                    if(columnValue != null && columnValue.toString().length() > 4000) {
//                    	try {
//							Clob clob=new javax.sql.rowset.serial.SerialClob(columnValue.toString().toCharArray());
//							valuesPart.append(clob);   
//						} catch (SQLException e) {
//							e.printStackTrace();
//						} 
//                    }else {
//                    	valuesPart.append(columnValue);
//                    }
//                    valuesPart.append("'");
//                }
//
//                if (count < keySet.size() - 1) {
//                    columnPart.append(", ");
//                    valuesPart.append(", ");
//                }
//                count++;
//            }
//            columnPart.append(") ");
//            valuesPart.append(") ");
//            return columnPart.append(valuesPart).toString();
        }
    }


}
