package com.unis.hlht.cjlksj.server.mapper;

import com.unis.hlht.cjlksj.server.dto.spjkxx.SPJKXXSxtDTO;
import com.unis.hlht.cjlksj.server.dto.spjkxx.SPJKXXTreeDTO;
import com.unis.hlht.cjlksj.server.entity.SPJKXXEntity;
import com.unis.hlht.cjlksj.server.mymapper.MyMapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.poi.ss.formula.functions.T;

import java.util.List;

/**
 * 功能描述: 视频信息mapper层
 *
 * @Auther: 蒋青茂
 * @Date: 2019-5-8 11:11
 */
@SuppressWarnings("all")
public interface SPJKXXMapper extends MyMapper<SPJKXXEntity> {

    @Select("SELECT * FROM DIM_HY_SPJKXX T WHERE T.ID = #{id}")
    SPJKXXEntity findById(@Param("id") String id);


    @Select("SELECT T.DWDM ,T.KQMC FROM DIM_HY_SPJKXX T WHERE T.DWDM = #{dwdm}")
    List<SPJKXXTreeDTO> findNameByDwdm(@Param("dwdm") String dwdm);

//    @Select("select  T.DWDM FROM DIM_HY_SPJKXX  T  GROUP BY T.DWDM")
    @Select({"<script>",
            "SELECT T.DWDM as dwdm,max(T.KQMC) as kqmc,max(t.tyshxydm) as tyshxydm FROM DIM_HY_SPJKXX T",
            "WHERE 1=1",
            "<if test='kqmc!=null'>",
            "AND T.KQMC like '%${kqmc}%'",
            "</if>",
            "GROUP BY T.DWDM",
            "</script>"})
    List<SPJKXXTreeDTO> findLeftTree(@Param("kqmc") String kqmc);

    //@Select("SELECT T.SBMC,T.ID,T.KQMC,T.DWDM FROM DIM_HY_SPJKXX T WHERE T.DWDM = #{dwdm} AND T.JKLB != 3 order BY " +
    //"to_number (regexp_substr(T.SBMC,'[0-9]*[0-9]',1))")
    @Select("select t.sbmc,max(t.id) id from DIM_HY_SPJKXX t where t.dwdm = #{dwdm} and t.tyshxydm = #{tyshxydm}  " +
            "group" +
            " " +
            "by t.sbmc")
    List<SPJKXXSxtDTO> findByDwdmTree(@Param("dwdm") String dwdm,@Param("tyshxydm")String tyshxydm);

        @Select("SELECT T.SBMC,T.ID,T.KQMC,T.DWDM FROM DIM_HY_SPJKXX T WHERE T.DWDM = #{dwdm} AND T.JKLB != 3 order BY to_number (regexp_substr(T.SBMC,'[0-9]*[0-9]',1))")
    List<SPJKXXSxtDTO> findByDwdm(@Param("dwdm") String dwdm);
}
