package com.unis.hlht.cjlksj.server.mapper;

import org.apache.ibatis.annotations.*;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

@Mapper
public interface TestMapper {

	@Select("select SPWJL from ODS_UP_SPJKYCSJGJJBXXJK_BAK order by GJSJ desc ")
	List<String> findWjxxWjl();
	@Select("select ID,SPWJL from ODS_UP_SPJKYCSJGJJBXXJK_BAK")
	List<Map<String,String>> findWjxxWjlOfMap();

	@Select({ "<script> "
			+ "select TABLE_NAME,COMMENTS from TABLE_COMMENT_MAP",
			"</script>" })
	List<Map> findByTableName();

	@Select({ "<script> "
			+ "select count(1) num from ${tableName} where czbz in ('i','u')",
			"</script>" })
	Integer findDataCount(@Param("tableName") String tableName);

	@Select({ "<script> "
			+ "select count(1) num from ${tableName} where czbz in ('i','u')",
			"</script>" })
	Integer findDataCountByDwdm(@Param("tableName") String tableName,@Param("dwdm") String dwdm);

	@Select({ "<script> "
			+ "select KQDM from KQXX_DELETE_RECORD",
			"</script>" })
	List<String> findDeleteKqdm();

	@Select({ "<script> "
			+ "select count(1) num from ODS_UP_CFXXJK where KQDM = #{kqdm}",
			"</script>" })
	Integer findCfylsj(@Param("kqdm") String kqdm);

//	@Select({ "<script> "
//			+ "select count(1) num from ODS_UP_AJXXJK where AJDH like '${kqdm}%'",
//			"</script>" })
	@SelectProvider(type = SqlProvider.class, method = "findAjylsj")
	Integer findAjylsj(String kqdm);

	@SelectProvider(type = SqlProvider.class, method = "findHwylsj")
	Integer findHwylsj(String kqdm);

	@SelectProvider(type = SqlProvider.class, method = "findYgylsj")
	Integer findYgylsj(String kqdm);

	@SelectProvider(type = SqlProvider.class, method = "findLsrkylsj")
	Integer findLsrkylsj(String kqdm);

	@SelectProvider(type = SqlProvider.class, method = "findLsrkjyylsj")
	Integer findLsrkjyylsj(String kqdm);

	@SelectProvider(type = SqlProvider.class, method = "findLsrkjsylsj")
	Integer findLsrkjsylsj(String kqdm);

	@SelectProvider(type = SqlProvider.class, method = "findCkxxylsj")
	Integer findCkxxylsj(String kqdm);

	@SelectProvider(type = SqlProvider.class, method = "findCkjsylsj")
	Integer findCkjsylsj(String kqdm);

	@SelectProvider(type = SqlProvider.class, method = "findLskcylsj")
	Integer findLskcylsj(String kqdm);

	@SelectProvider(type = SqlProvider.class, method = "findSydylsj")
	Integer findSydylsj(String kqdm);

	class SqlProvider {
		public String findAjylsj(String kqdm) {
			String sql = "select count(1) num from ODS_UP_AJXXJK " +
					"where AJDH like '"+kqdm+"%'";
			System.out.println(sql);
			return sql;
		}

		public String findHwylsj(String kqdm) {
			String sql = "select count(1) num from ODS_UP_HWXXJK " +
					"where HWDM like '"+kqdm+"%'";
			System.out.println(sql);
			return sql;
		}

		public String findYgylsj(String kqdm) {
			String sql = "select count(1) num from ODS_UP_YGXXJK where KQDM = '" + kqdm +"'";
			System.out.println(sql);
			return sql;
		}

		public String findLsrkylsj(String kqdm) {
			String sql = "select count(1) num from ODS_UP_LSRKXXJK where HWDM like '" + kqdm +"%'";
			System.out.println(sql);
			return sql;
		}

		public String findLsrkjyylsj(String kqdm) {
			String sql = "select count(1) num from ODS_UP_LSRKJYXXJK where HWDM like '" + kqdm +"%'";
			System.out.println(sql);
			return sql;
		}

		public String findLsrkjsylsj(String kqdm) {
			String sql = "select count(1) num from ODS_UP_LSRKJSXXJK where HWDM like '" + kqdm +"%'";
			System.out.println(sql);
			return sql;
		}

		public String findCkxxylsj(String kqdm) {
			String sql = "select count(1) num from ODS_UP_LSCKXXJK where HWDM like '" + kqdm +"%'";
			System.out.println(sql);
			return sql;
		}

		public String findCkjsylsj(String kqdm) {
			String sql = "select count(1) num from ODS_UP_LSCKJSXXJK where CKJSDH like '" + kqdm +"%'";
			System.out.println(sql);
			return sql;
		}

		public String findLskcylsj(String kqdm) {
			String sql = "select count(1) num from ODS_UP_LSKCXXJK where HWDM like '" + kqdm +"%'";
			System.out.println(sql);
			return sql;
		}

		public String findSydylsj(String kqdm) {
			String sql = "select count(1) num from ODS_UP_SYDXXJK where HWDM like '" + kqdm +"%'";
			System.out.println(sql);
			return sql;
		}
	}

	@Select({ "<script> "
			+ "select TABLE_NAME,DELETE_COL,COMMENTS from TABLE_COMMENT_MAP where IS_EXIST = 1",
			"</script>" })
	List<Map<String,String>> findDeleteTableAndCol();

	@Select("select count(*) num from  ${tableName} WHERE ${delColumn} like #{dwdm} and czbz in ('i','u')")
	Integer countDwDataByDwdm(@Param("tableName") String tableName,
						   @Param("delColumn") String delColumn,
						   @Param("dwdm") String dwdm);

	@Select("select ${delColumn} num from  ${tableName} WHERE ${delColumn} like #{dwdm} and czbz != 'd'")
	List<String> selectDwDataByDwdm(@Param("tableName") String tableName,
							   @Param("delColumn") String delColumn,
							   @Param("dwdm") String dwdm);

	@Transactional(rollbackFor = Exception.class)
	@Update("update ${tableName} SET czbz = 'd',is_upload = 0 WHERE ${delColumn} like #{dwdm} and czbz in ('i','u')")
	int deleteDwDataByDwdmLike(@Param("tableName") String tableName,
						   @Param("delColumn") String delColumn,
						   @Param("dwdm") String dwdm);

	@Transactional(rollbackFor = Exception.class)
	@Update("update ${tableName} SET czbz = 'd',is_upload = 0 WHERE ${delColumn} = #{delValue} and czbz != 'd'")
	int deleteDwDataByDwdm(@Param("tableName") String tableName,
						   @Param("delColumn") String delColumn,
						   @Param("delValue") String delValue);

	@Transactional(rollbackFor = Exception.class)
	@Update("update ${tableName} SET czbz = 'i',is_upload = 0 WHERE ${delColumn} like #{dwdm}")
	int restoreDwDataByDwdm(@Param("tableName") String tableName,
						   @Param("delColumn") String delColumn,
						   @Param("dwdm") String dwdm);


	@Select("select ID, HWDM, ZJKLXJ, QZQTKL, QTKL from ODS_UP_LSRKXXJK where HWDM like #{dwdm}")
	List<Map<String,Object>> findLsrkxx(@Param("dwdm") String dwdm);

	@Select("select ID,HWDM from ODS_UP_LSKCXXJK where HWDM like #{dwdm}")
	List<Map<String,Object>> findLskcxx(@Param("dwdm") String dwdm);

	@Transactional(rollbackFor = Exception.class)
	@Update("update ODS_UP_LSRKXXJK set ZJKLXJ=#{zjklxj}," +
			"QZQTKL=#{qzqtkl},QTKL=#{qtkl},czbz='u',is_upload=0 where id=#{id} and HWDM=#{hwdm}")
	int updateLsrkxx(@Param("id") String id, @Param("hwdm") String hwdm,
					 @Param("zjklxj") Double zjklxj,@Param("qzqtkl") Double qzqtkl,@Param("qtkl") Double qtkl);

	@Transactional(rollbackFor = Exception.class)
	@Update("update ODS_UP_LSKCXXJK set czbz='d',is_upload=0 where id=#{id} and HWDM=#{hwdm}")
	int updateLskcxx(@Param("id") String id, @Param("hwdm") String hwdm);

	@Select("select RKYWDH,HWDM,count(1) NUM from ODS_UP_LSRKXXJK group by RKYWDH,HWDM")
	List<Map<String,Object>> countLsrkxxByKey();
	@Select("select ZJBGDH,HWDM,count(1) NUM from ODS_UP_ZJXXJK group by ZJBGDH,HWDM")
	List<Map<String,Object>> countZjxxByKey();

	@Select("select ID from ODS_UP_LSRKXXJK where RKYWDH = #{rkywdh} and HWDM = #{hwdm} order by LOAD_DATE")
	List<Map<String,Object>> findLsrkxxByRkywdhAndHwdm(@Param("rkywdh") String rkywdh,@Param("hwdm") String hwdm);
	@Select("select ID from ODS_UP_ZJXXJK where ZJBGDH = #{zjbgdh} and HWDM = #{hwdm} order by LOAD_DATE")
	List<Map<String,Object>> findZjxxByZjbgdhAndHwdm(@Param("zjbgdh") String zjbgdh,@Param("hwdm") String hwdm);

	@Transactional(rollbackFor = Exception.class)
	@Delete("delete from ${tableName} where id = #{id}")
	void deleteTableById(@Param("id") String id, @Param("tableName") String tableName);

	@Transactional(rollbackFor = Exception.class)
	@Update("update ${tableName} set is_upload = 0 where id = #{id}")
	int updateTableById(@Param("id") String id, @Param("tableName") String tableName);

	@Select("select DWDM,DWMC from ODS_UP_DWXXJK where czbz in ('i','u')")
	List<Map<String,Object>> findDwdmAndMc();

	@Select("select KQDM,KQMC from ODS_UP_KQXXJK where CZBZ in ('i','u') and DWDM = #{dwdm}")
	List<Map<String,Object>> findKqdmAndMc(@Param("dwdm") String dwdm);

	@Transactional(rollbackFor = Exception.class)
	@Delete("delete from ${tableName} where czbz not in ('i','u') or IS_UPLOAD not in (0,1)")
	void deleteCzbzIsD(@Param("tableName") String tableName);

	@Select("select a.HWDM,a.RCSJ,LQGSDWDM,LSPZDM,LSXZDM,SHND,CD,JJSL from ODS_UP_LSKCXXJK a join " +
			"(select HWDM,max(RCSJ) RCSJ from ODS_UP_LSKCXXJK where czbz in ('i','u') and JJSL is not null and JJSL != 0 and hwdm not in\n" +
			"(select a.HWDM from ODS_UP_HWXXJK a join ODS_UP_LSKCXXJK b on a.HWDM = b.HWDM " +
			"join (select hwdm from ODS_UP_LSRKXXJK where czbz in ('i','u')  group by hwdm) c on b.HWDM = c.HWDM " +
			"where a.czbz in ('i','u') and b.czbz in ('i','u') and b.JJSL is not null and b.JJSL != 0) GROUP by HWDM) b " +
			"on a.HWDM = b.HWDM and a.RCSJ = b.RCSJ  where czbz in ('i','u') and LSPZDM not in (" +
			"'2311001','2311002','2311006','2311003','2311004','2311005','2320000','2312003','2314000','2364000','2360000'," +
			"'2361000','2361001','2361002','2362000','2362001','2362002','2342003','2342001','2111000','2113000','2114000'," +
			"'2130000','2115000','2118000','2121000','2140000','2150000','2123000','2124000','2125000','2128000','2185000'," +
			"'2189000','2190000','2191000','2192000','2193000','2194000','2195000','2196000','2197000','2198000','3223000'," +
			"'3224000','3225000')")
	List<Map<String,Object>> selectNoLsrkKcxx();

	@Select("select CYR,LXDH,SFZH,YSGJ,CCHLX,CCH,DJMGRYXM,MZJLY,ZCY,PZJLY,CMQRMGRYXM,YWRQ  from ODS_UP_LSRKXXJK where czbz in ('i','u')")
	List<Map<String,String>> selectLsrkxxForInit();

	@Select("select distinct HWDM from ODS_UP_LSKCXXJK where czbz in ('i','u') and HWZT = 3 and JJSL is not null and JJSL != 0 and LSPZDM not in (\n" +
			"'2311001','2311002','2311006','2311003',\n" +
			"'2311004','2311005','2320000','2312003','2314000','2364000','2360000','2361000','2361001','2361002','2362000','2362001','2362002','2342003',\n" +
			"'2342001','2111000','2113000','2114000','2130000','2115000','2118000','2121000','2140000','2150000','2123000','2124000','2125000','2128000',\n" +
			"'2185000','2189000','2190000','2191000','2192000','2193000','2194000','2195000','2196000','2197000','2198000','3223000','3224000','3225000'\n" +
			"    ) and hwdm not in\n" +
			"(select a.HWDM from ODS_UP_WSDJCXXJK a join\n" +
			"(select HWDM from ODS_UP_LSKCXXJK where czbz in ('i','u') and HWZT = 3 and LSPZDM not in (\n" +
			"'2311001','2311002','2311006','2311003',\n" +
			"'2311004','2311005','2320000','2312003','2314000','2364000','2360000','2361000','2361001','2361002','2362000','2362001','2362002','2342003',\n" +
			"'2342001','2111000','2113000','2114000','2130000','2115000','2118000','2121000','2140000','2150000','2123000','2124000','2125000','2128000',\n" +
			"'2185000','2189000','2190000','2191000','2192000','2193000','2194000','2195000','2196000','2197000','2198000','3223000','3224000','3225000'\n" +
			"    ) group by HWDM) b on a.HWDM = b.HWDM where a.czbz in ('i','u') group by a.HWDM)")
	List<Map<String,String>> selectNoWsdKcxx();

	@Select("select HWDM,LSPZDM,LSDJDM,RCSJ,FCRQ,JJSL from ODS_UP_LSKCXXJK where czbz in ('i','u') and HWZT = 3 and JJSL is not null and JJSL != 0 and LSPZDM not in (\n" +
			"'2311001','2311002','2311006','2311003',\n" +
			"'2311004','2311005','2320000','2312003','2314000','2364000','2360000','2361000','2361001','2361002','2362000','2362001','2362002','2342003',\n" +
			"'2342001','2111000','2113000','2114000','2130000','2115000','2118000','2121000','2140000','2150000','2123000','2124000','2125000','2128000',\n" +
			"'2185000','2189000','2190000','2191000','2192000','2193000','2194000','2195000','2196000','2197000','2198000','3223000','3224000','3225000'\n" +
			"    ) and hwdm not in\n" +
			"(select a.HWDM from ODS_UP_ZJXXJK a join\n" +
			"(select HWDM from ODS_UP_LSKCXXJK where czbz in ('i','u') and HWZT = 3 and LSPZDM not in (\n" +
			"'2311001','2311002','2311006','2311003',\n" +
			"'2311004','2311005','2320000','2312003','2314000','2364000','2360000','2361000','2361001','2361002','2362000','2362001','2362002','2342003',\n" +
			"'2342001','2111000','2113000','2114000','2130000','2115000','2118000','2121000','2140000','2150000','2123000','2124000','2125000','2128000',\n" +
			"'2185000','2189000','2190000','2191000','2192000','2193000','2194000','2195000','2196000','2197000','2198000','3223000','3224000','3225000'\n" +
			"    ) group by HWDM) b on a.HWDM = b.HWDM where a.czbz in ('i','u') group by a.HWDM)")
	List<Map<String,Object>> selectNoZjKcxx();

	@Select("select JYR,ZBLB,JYXM,JYXMZ,ZBJGPD,SHRXM,QYSJ,QYQY,QYRXM,YPBH,YPSL,DBSL,YPDJ from ODS_UP_ZJXXJK " +
			"where LSPZDM = #{lspzdm} and JYLB = '01' and czbz in ('i','u') and DEP_DWDM is null")
	List<Map<String,Object>> selectZjxxForInit(@Param("lspzdm") String lspzdm);

	@Select("select DWMC from ODS_UP_DWXXJK where czbz in ('i','u') and DWDM = #{dwdm}")
	Map<String,String> selectDwxx(@Param("dwdm") String dwdm);

}
