package com.unis.hlht.cjlksj.server.redisstream;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.Map;
import java.util.Objects;

@Slf4j
@Service
public class StreamRedisQueue {

    // 队列名
    public static final String NOTICE_UPLOAD_STREAM_KEY = "notice_upload";

    @Autowired
    private RedisTemplate<String, Object> redisTemplate;

    public String produce(Map<String, String> value) {
        return Objects.requireNonNull(redisTemplate.opsForStream().add(NOTICE_UPLOAD_STREAM_KEY, value)).getValue();
    }

    public void createGroup(String key, String group) {
        redisTemplate.opsForStream().createGroup(key, group);
    }

}