package com.unis.hlht.cjlksj.server.utils;

import java.util.*;

/**
 * 获取表中逻辑主键
 *
 * @author 马伟栋
 * @date 2020/03/23-10:30
 **/
public class LogicKeyUtil {

    private static Map<String, List<String>> primeryKeysMap = new HashMap<>();

    private static List<String> notVerifyTables = new ArrayList<String>();

    static {
        // 仓储单位信息
        primeryKeysMap.put("ODS_UP_DWXXJK", new ArrayList<>(Arrays.asList("DWDM")));
        // 人员信息
        primeryKeysMap.put("ODS_UP_RYXXJK", new ArrayList<>(Arrays.asList("DWDM", "SFZHM")));
        // 库区信息
        primeryKeysMap.put("ODS_UP_KQXXJK", new ArrayList<>(Arrays.asList("KQDM")));
        // 仓房信息
        primeryKeysMap.put("ODS_UP_CFXXJK", new ArrayList<>(Arrays.asList("CFDM")));
        // 厫间信息
        primeryKeysMap.put("ODS_UP_AJXXJK", new ArrayList<>(Arrays.asList("AJDH")));
        // 货位信息
        primeryKeysMap.put("ODS_UP_HWXXJK", new ArrayList<>(Arrays.asList("HWDM")));
        // 油罐信息
        primeryKeysMap.put("ODS_UP_YGXXJK", new ArrayList<>(Arrays.asList("YGDM")));
        // 设备信息
        primeryKeysMap.put("ODS_UP_SBXXJK", new ArrayList<>(Arrays.asList("KQDM", "SBBH")));
        // 客户信息
        primeryKeysMap.put("ODS_UP_KHXXJK", new ArrayList<>(Arrays.asList("DWDM", "KHTYSHXYDMHSFZH")));
        // 药剂信息
        primeryKeysMap.put("ODS_UP_YJXXJK", new ArrayList<>(Arrays.asList("YJBH", "KQDM", "CGRQ")));
        // 入库信息
        primeryKeysMap.put("ODS_UP_LSRKXXJK", new ArrayList<>(Arrays.asList("HWDM", "RKYWDH")));
        // 入库检验信息
        primeryKeysMap.put("ODS_UP_LSRKJYXXJK", new ArrayList<>(Arrays.asList("HWDM", "RKJYDH")));
        // 入库结算信息
        primeryKeysMap.put("ODS_UP_LSRKJSXXJK", new ArrayList<>(Arrays.asList("RKJSDH")));
        // 出库信息
        primeryKeysMap.put("ODS_UP_LSCKXXJK", new ArrayList<>(Arrays.asList("HWDM", "CKYWDH")));
        // 出库结算信息
        primeryKeysMap.put("ODS_UP_LSCKJSXXJK", new ArrayList<>(Arrays.asList("CKJSDH")));
        // 合同信息
        primeryKeysMap.put("ODS_UP_HTXXJK", new ArrayList<>(Arrays.asList("DWDM", "HTH")));
        // 倒仓信息
        primeryKeysMap.put("ODS_UP_DCXXJK", new ArrayList<>(Arrays.asList("DCDH")));
        // 粮食性质转变单信息
        primeryKeysMap.put("ODS_UP_LSXZZBDXXJK", new ArrayList<>(Arrays.asList("LSXZZBDH")));
        // 粮食库存信息
        primeryKeysMap.put("ODS_UP_LSKCXXJK", new ArrayList<>(Arrays.asList("HWDM")));
        // 粮食账面库存信息
        primeryKeysMap.put("ODS_UP_ZMKCXXJK", new ArrayList<>(Arrays.asList("KQDM", "LSPZDM", "ND", "YF")));
        // 存储质检明细信息
        primeryKeysMap.put("ODS_UP_ZJXXJK", new ArrayList<>(Arrays.asList("HWDM", "ZJBGDH")));
        // 温湿度检测数据
        primeryKeysMap.put("ODS_UP_WSDJCXXJK", new ArrayList<>(Arrays.asList("WSDJCDH")));
        // 气体检测数据
        primeryKeysMap.put("ODS_UP_QTJCXXJK", new ArrayList<>(Arrays.asList("QTNDJCDH")));
        // 虫情检测数据
        primeryKeysMap.put("ODS_UP_CHJCXXJK", new ArrayList<>(Arrays.asList("HCJCDH")));
        // 通风作业数据
        primeryKeysMap.put("ODS_UP_TFZYXXJK", new ArrayList<>(Arrays.asList("TFZYDH")));
        // 熏蒸作业
        primeryKeysMap.put("ODS_UP_XZZYXXJK", new ArrayList<>(Arrays.asList("XZZYDH")));
        // 原粮损失损耗数据
        primeryKeysMap.put("ODS_UP_SYDXXJK", new ArrayList<>(Arrays.asList("SYDH")));
        // 安全事故数据
        primeryKeysMap.put("ODS_UP_AQGLXXJK", new ArrayList<>(Arrays.asList("KQDM", "FXDBM")));
        // 储备规模数据
        primeryKeysMap.put("ODS_UP_CBGMXXJK", new ArrayList<>(Arrays.asList("CCQY", "NF", "YLPZ", "YLXZ")));
        // 轮换计划信息
        primeryKeysMap.put("ODS_UP_LHJHXXJK", new ArrayList<>(Arrays.asList("LHJHDH")));
        // 轮换计划明细信息
        primeryKeysMap.put("ODS_UP_LHJHMXXXJK", new ArrayList<>(Arrays.asList("JHMXDH")));
        // 文件信息
        primeryKeysMap.put("ODS_UP_WJXXJK", new ArrayList<>(Arrays.asList("KQDM", "WJMC", "WJLX")));
        // 库区图仓房点位标注信息
        primeryKeysMap.put("ODS_UP_KQTCFDWBZSJXXJK", new ArrayList<>(Arrays.asList("DWDM", "KQDM", "HWDM")));
        // 库区图视频监控点位标注信息
        primeryKeysMap.put("ODS_UP_KQTSPJKSBDWBZSJXXJK", new ArrayList<>(Arrays.asList("DWDM", "KQDM", "SPJKSBID")));
        // 仓内视频图像信息
        primeryKeysMap.put("ODS_UP_CNSPTXXXJK", new ArrayList<>(Arrays.asList("CFDM", "SPJKSBID", "ZPSJ", "YZWBH")));
        // 视频监控异常事件告警信息
        primeryKeysMap.put("ODS_UP_SPJKYCSJGJJBXXJK", new ArrayList<>(Arrays.asList("KQDM", "GJSJ")));
        // 违规预警信息
        primeryKeysMap.put("ODS_UP_WGYJXXJK", new ArrayList<>(Arrays.asList("YJXXDM")));
        // 财务报表信息
        primeryKeysMap.put("ODS_UP_CWBBXXJK", new ArrayList<>(Arrays.asList("DWDM", "BBSJ", "BBM", "ZBXH")));
    }

    public static List<String> getprimeryKeys(String tableName) {
        return primeryKeysMap.get(tableName);
    }


    public static boolean notVerify(String tableName) {
        return notVerifyTables.contains(tableName);
    }

}
