package com.unis.hlht.cjlksj.server.utils;

import java.util.*;

/**
 * 获取表中逻辑主键
 *
 * @author 马伟栋
 * @date 2020/03/23-10:30
 **/
public class LogicKeyUtilBak {

    private static Map<String, List<String>> primeryKeysMap = new HashMap<>();

    private static List<String> notVerifyTables = new ArrayList<String>();

    static {
        // 仓储单位信息
        primeryKeysMap.put("ODS_UP_DWXXJK", new ArrayList<>(Arrays.asList("DWDM")));
        // 库区信息
        primeryKeysMap.put("DIM_HY_KQQKB", new ArrayList<>(Arrays.asList("KDBM")));
        // 仓房信息
        primeryKeysMap.put("DIM_HY_CFQKB", new ArrayList<>(Arrays.asList("CFBH")));
        // 厫间信息
        primeryKeysMap.put("DIM_HY_AJQKB", new ArrayList<>(Arrays.asList("AJDH")));
        // 货位信息
        primeryKeysMap.put("DIM_HY_HWQKB", new ArrayList<>(Arrays.asList("HWBH")));
        // 油罐信息
        primeryKeysMap.put("DIM_HY_YGQKB", new ArrayList<>(Arrays.asList("YGBH")));
        // 文件信息
        primeryKeysMap.put("DIM_HY_WJQKB", new ArrayList<>(Arrays.asList("KQDM", "WJMC")));
        // 粮食入库信息
        primeryKeysMap.put("DIM_CRK_RKXX", new ArrayList<>(Arrays.asList("RKLSH", "HWBM")));
        // 粮食入库检验信息
        primeryKeysMap.put("DIM_CRK_RKJYXX", new ArrayList<>(Arrays.asList("RKJYDH", "HWDM")));
        // 粮食入库结算信息
        primeryKeysMap.put("DIM_CRK_RKJSXX", new ArrayList<>(Arrays.asList("RKJSDH")));
        // 粮食出库信息
        primeryKeysMap.put("DIM_CRK_CKXX", new ArrayList<>(Arrays.asList("CKYWDH", "HWBM")));
        // 粮食出库结算信息
        primeryKeysMap.put("DIM_CRK_CKJSXX", new ArrayList<>(Arrays.asList("CKJSDH")));
        // 倒仓信息
        primeryKeysMap.put("DIM_CRK_DCXX", new ArrayList<>(Arrays.asList("DCDH")));
        // 粮食库存信息
        primeryKeysMap.put("DIM_CRK_KCXX", new ArrayList<>(Arrays.asList("HWDM", "LSPZDM", "RCSJ")));
//        primeryKeysMap.put("DIM_CRK_KCXX", new ArrayList<>(Arrays.asList("HWDM", "LSPZDM", "RCSJ")));
        // 原粮损失损耗数据源
        primeryKeysMap.put("DIM_HY_LSCC_YLSHXXB", new ArrayList<>(Arrays.asList("SYDH")));
        // 性质转变单信息
        primeryKeysMap.put("DIM_CRK_XZZBDXX", new ArrayList<>(Arrays.asList("LSXZZBDH")));
        // 温湿度检测数据
        primeryKeysMap.put("T_LSCC_WSDJCXXB", new ArrayList<>(Arrays.asList("WSDJCDH")));
        // 虫情检测数据元
        primeryKeysMap.put("DIM_HY_LSCC_CQJCXXB", new ArrayList<>(Arrays.asList("HCJCDH")));
        // 气体检测数据
        primeryKeysMap.put("DIM_HY_LSCC_QTJCXXB", new ArrayList<>(Arrays.asList("QTNDJCDH")));
        // 通风作业数据源
        primeryKeysMap.put("DIM_HY_LSCC_TFZYXXB", new ArrayList<>(Arrays.asList("TFZYDH")));
        // 熏蒸作业
        primeryKeysMap.put("DIM_HY_LSCC_XZZYXXB", new ArrayList<>(Arrays.asList("XZZYDH")));
        // 轮换计划
        primeryKeysMap.put("DIM_HY_LHJHXX",new ArrayList<>(Arrays.asList("LHJHDH")));
        // 轮换计划明细
        primeryKeysMap.put("DIM_HY_LHJHMXXX",new ArrayList<>(Arrays.asList("JHMXDH")));
        // 合同管理
        primeryKeysMap.put("DIM_HY_HTXXB", new ArrayList<>(Arrays.asList("HTBH", "TYSHXYDM")));
        // 存储质检明细信息
        primeryKeysMap.put("DIM_HY_LSCC_ZCZJMXB", new ArrayList<>(Arrays.asList("ZJBGDBH", "HWBM")));
        
        
        //0509
		// 6.2.6 价格信息
		primeryKeysMap.put("DIM_HYJGXXB", new ArrayList<>(Arrays.asList("JGBH")));
		// 6.2.7 设备管理数据
		primeryKeysMap.put("DIM_HY_LSCC_SBGLXXB", new ArrayList<>(Arrays.asList("SBBH")));
		//6.2.8	客户信息
		primeryKeysMap.put("DIM_HY_KHXXQKB", new ArrayList<>(Arrays.asList("KHBM")));
		
		//6.2.9	车辆信息
		primeryKeysMap.put("DIM_HY_CLXXQKB", new ArrayList<>(Arrays.asList("CPHM")));
		//6.2.10文档信息
		primeryKeysMap.put("DIM_HY_WDXXB", new ArrayList<>(Arrays.asList("WDBH")));
		//6.3.1.6出入库计划
		primeryKeysMap.put("DIM_HY_JHXDXXB", new ArrayList<>(Arrays.asList("JHLRBH")));
		
		//6.3.1.7	计划执行
		primeryKeysMap.put("DIM_HY_JHZXXXB", new ArrayList<>(Arrays.asList("JHZXXH")));
		//6.3.1.9	值仓信息加ZCBH(HWBH+日期8位+3位流水号)	
		primeryKeysMap.put("DIM_HY_CRK_ZCXXB", new ArrayList<>(Arrays.asList("ZCBH")));
		//6.3.2.8	数量检测数据元
		primeryKeysMap.put("DIM_HY_LSCC_SLJCXXB", new ArrayList<>(Arrays.asList("JCBH")));
		//6.3.2.11	药剂管理
		primeryKeysMap.put("DIM_HY_LSCC_YPGLXXB", new ArrayList<>(Arrays.asList("YPLXBM")));
		//6.3.2.14	能耗监测数据源
		primeryKeysMap.put("DIM_HY_LSCC_NHJCXXB", new ArrayList<>(Arrays.asList("JCBH")));
		//6.3.3.1	三防预案数据源
		primeryKeysMap.put("DIM_HY_LSCC_SFAQYA", new ArrayList<>(Arrays.asList("YABH")));
		//6.3.3.2	安全事故数据源
		primeryKeysMap.put("DIM_HY_LSCC_AQSGXXB", new ArrayList<>(Arrays.asList("ID")));
		//6.3.4.1	项目概况数据源
		primeryKeysMap.put("DIM_HY_KXCL_XMGKXXB", new ArrayList<>(Arrays.asList("XMBH")));
//		//6.3.4.2	项目人员数据源
		primeryKeysMap.put("DIM_HY_KXCL_XMRYXXB", new ArrayList<>(Arrays.asList("ZJHM")));
		//6.3.4.3	项目费用数据源
		primeryKeysMap.put("DIM_HY_KXCL_XMFYXXB", new ArrayList<>(Arrays.asList("XMBH")));
		//6.3.4.4	项目验收数据源--加一个字段XMBH
		primeryKeysMap.put("DIM_HY_KXCL_XMYSXXB", new ArrayList<>(Arrays.asList("XMBH")));
		//6.3.5.1	*储备规模数据源*
		primeryKeysMap.put("DIM_HY_LYLH_CBGMB", new ArrayList<>(Arrays.asList("JHBH")));
		//储备粮油轮换计划
		primeryKeysMap.put("DIM_HY_LYLH_JHXDXXB", new ArrayList<>(Arrays.asList("JHBM")));
		//6.3.5.3	轮换申请数据源
		primeryKeysMap.put("DIM_HY_LYLH_LHSQB", new ArrayList<>(Arrays.asList("LHSQH","LHSQZ")));
		//6.3.5.4	轮换批复数据源
		primeryKeysMap.put("DIM_HY_LYLH_LHPFB", new ArrayList<>(Arrays.asList("LHPFZ","LHPFH")));
		//6.3.5.5	轮换执行申请数据源
		primeryKeysMap.put("DIM_HY_LYLH_LHZXSQB", new ArrayList<>(Arrays.asList("LHPFZ","LHPFH")));
//		//6.3.5.6	轮换执行批复
		primeryKeysMap.put("DIM_HY_LYLH_LHZXPFB", new ArrayList<>(Arrays.asList("LHZHXH")));
//		//6.3.5.8	轮换费用审核
		primeryKeysMap.put("DIM_HY_LYLH_LHFYSHB", new ArrayList<>(Arrays.asList("LHPFZ","LHPFH")));
		//6.3.5.9	*轮换质检报告*
		primeryKeysMap.put("DIM_HY_LYLH_REPORT", new ArrayList<>(Arrays.asList("BGBH")));
		//6.3.5.10	*轮换质检明细数据源*
		primeryKeysMap.put("DIM_HY_LYLH_CHECKITEM", new ArrayList<>(Arrays.asList("JYXMBH")));
		//6.3.5.11	*轮换验收结论*
		primeryKeysMap.put("DIM_HY_LYLH_RESUKT", new ArrayList<>(Arrays.asList("LHPFH")));

		//6.1.1	行政机构信息
		primeryKeysMap.put("DIM_HY_XZJGJBXXQKB", new ArrayList<>(Arrays.asList("TYSHXYDM")));
		//6.1.4	*人员信息*
		primeryKeysMap.put("DIM_HY_DWRYXXB", new ArrayList<>(Arrays.asList("BGRYBH")));
		//6.3.2.4	粮情检测信息
		primeryKeysMap.put("DIM_HY_LSCC_LQJCXXB", new ArrayList<>(Arrays.asList("JCBH")));
		//6.3.2.2	保管台账
		primeryKeysMap.put("DIM_HY_LSCC_BGTZB", new ArrayList<>(Arrays.asList("ZKXH")));

		//6.1.3	质检机构信息
		primeryKeysMap.put("DIM_HY_ZJJGJBXXQKB", new ArrayList<>(Arrays.asList("ZZJGDM")));

		//视频信息
		primeryKeysMap.put("DIM_HY_SPJKXX", new ArrayList<>(Arrays.asList("IP","TYSHXYDM")));
//		//6.3.5.7	轮换验收申请数据源
		notVerifyTables.add("DIM_HY_LYLH_LHYSSQB");
    }

    public static List<String> getprimeryKeys(String tableName) {
        return primeryKeysMap.get(tableName);
    }
    
    
    public static boolean notVerify(String tableName) {
    	return notVerifyTables.contains(tableName);
    }

}
