package com.unis.hlht.cjlksj.server.utils;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * @description:响应码
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/02/19-13:57
 **/
@Getter
@Setter
public class ResponseCode {

    private static final String SUCCESS_CODE = "200";

    private static final String ERROR_CODE = "500";

    @JsonProperty("Code")
    private String code;

    @JsonProperty("VER")
    private String ver;

    public ResponseCode() {
    }

    public ResponseCode(String code, String ver) {
        this.code = code;
        this.ver = ver;
    }

    public static ResponseCode success() {
        return new ResponseCode("200", "处理成功！");
    }

    public static ResponseCode error() {
        return new ResponseCode("500", "处理失败！");
    }

    public static ResponseCode error(String ver) {
        return new ResponseCode("500", ver);
    }

}
