package com.unis.hlht.cjlksj.server.utils;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.unis.hlht.cjlksj.server.dto.upload.UploadDTO;
import lombok.Getter;
import lombok.Setter;

/**
 * @author
 * @description 统一数据传输响应
 * @since 2017年3月7日 上午10:08:42
 */
@Getter
@Setter
@SuppressWarnings("all")
public class ResponseWrapper {

    //报文标识
    @JsonProperty("ID")
    private String id;

    //报文版本号
    @JsonProperty("VER")
    private String ver;

    //命令发起时间
    @JsonProperty("SendTime")
    private String sendTime;

    //请求命令影响的行数
    @JsonProperty("Rows")
    private String rows;

    //执行消息内容
    @JsonProperty("MsgBody")
    private ResponseCode msgBody;


//    private static Integer Code200 = 200;
//    private static String Res200 = "请求已成功";
//    /**
//     * 请求失败
//     */
//    private static Integer Code500 = 500;
//    private static String Res500 = "请求失败";
//    /**
//     * 请求接口地址错误
//     */
//    private static Integer Code40101 = 40101;
//    private static String Res40101 = "请求接口地址错误";
//    /**
//     * 数据验签失败
//     */
//    private static Integer Code40102 = 40102;
//    private static String Res40102 = "数据验签失败";
//    /**
//     * 数据解密失败
//     */
//    private static Integer Code40103 = 40103;
//    private static String Res40103 = "数据解密失败";
//    /**
//     * 数据类型转换错误
//     */
//    private static Integer Code40104 = 40104;
//    private static String Res = "数据类型转换错误";
//    /**
//     * 数据条数超过最大限制
//     */
//    private static Integer Code40105 = 40105;
//    private static String Res40105 = "数据条数超过最大限制";
//    /**
//     * 数据摘要比对失败
//     */
//    private static Integer Code40106 = 40106;
//    private static String Res40106 = "数据摘要比对失败";
//    /**
//     * 请求参数错误
//     */
//    private static Integer Code40201 = 40201;
//    private static String Res40201 = "请求参数错误";
//    /**
//     * 上传的数据字段与实际接口的字段个数不一致
//     */
//    private static Integer Code40202 = 40202;
//    private static String Res40202 = "上传的数据字段与实际接口的字段个数不一致";
//    /**
//     * 请求数据缺少字段
//     */
//    private static Integer Code40203 = 40203;
//    private static String Res40203 = "请求数据缺少字段";
//    /**
//     * 数据校验错误
//     */
//    private static Integer Code40204 = 40204;
//    private static String Res40204 = "数据校验错误";
//    /**
//     * 指令下发失败
//     */
//    private static Integer Code40301 = 40301;
//    private static String Res40301 = "指令下发失败";
//    /**
//     * 暂无此接口
//     */
//    private static Integer Code40401 = 40401;
//    private static String Res40401 = "暂无此接口";
//    /**
//     * 无权限
//     */
//    private static Integer Code40402 = 40402;
//    private static String Res40402 = "无权限";
//    /**
//     * 信息不存在
//     */
//    private static Integer Code40403 = 40403;
//    private static String Res40403 = "信息不存在";
//    /**
//     * 其他未知错误
//     */
//    private static Integer Code40500 = 40500;
//    private static String Res40500 = "其他未知错误";
//    /**
//     * 无权限访问该接口
//     */
//    private static Integer Code40501 = 40501;
//    private static String Res40501 = "无权限访问该接口";
//    /**
//     * 数据库信息不存在
//     */
//    private static Integer Code40502 = 40502;
//    private static String Res40502 = "数据库信息不存在";
//    /**
//     * 服务接口已下线
//     */
//    private static Integer Code40503 = 40503;
//    private static String Res40503 = "服务接口已下线";
//    /**
//     * 访问次数超过最大限制
//     */
//    private static Integer Code40504 = 40504;
//    private static String Res40504 = "访问次数超过最大限制";

    /**
     * 无参构造器
     */
    public ResponseWrapper() {
    }

    /**
     * @param id
     * @param ver
     * @param sendTime
     * @param type
     * @param rows
     * @param msgBody
     */
    public ResponseWrapper(String id, String ver, String sendTime, String rows, ResponseCode msgBody) {
        this.id = id;
        this.ver = ver;
        this.sendTime = sendTime;
        this.rows = rows;
        this.msgBody = msgBody;
    }

    /**
     * 成功状态处理
     *
     * @param dto
     * @param rows
     * @return
     */
    public static ResponseWrapper success(UploadDTO dto, String rows) {
        return new ResponseWrapper(dto.getId(), dto.getVer(), dto.getSendTime(), rows, ResponseCode.success());
    }

    /**
     * 失败状态处理
     *
     * @param dto
     * @return
     */
    public static ResponseWrapper error(UploadDTO dto) {
        return new ResponseWrapper(dto.getId(), dto.getVer(), dto.getSendTime(), "0", ResponseCode.error());
    }

    /**
     * 失败状态处理
     *
     * @param dto
     * @return
     */
    public static ResponseWrapper error(UploadDTO dto, String errorMsg) {
        return new ResponseWrapper(dto.getId(), dto.getVer(), dto.getSendTime(), "0", ResponseCode.error(errorMsg));
    }

}